clc;clear;close all;

%read file, channel setup
SNR=15; % don't change!!! This is for channel noise generation.
[wave_gt,fs_gt] = audioread('gt.wav');
[x, fs] = audioread('noisytbt.wav');
wave_gt = wave_gt(:, 1)';
tb1=0.06803;

%Denoising
fprintf('\n\nDenoising starts!\n\n');
[wave,fs]=denoise(x,fs,15);
fprintf('\n\nDenoising finishes!\n\n');

%Autotune with groud truth alg4
fprintf('Autotuning with ground truth algo4 starts!\n\n');
new=gt_timedomain(wave,fs,wave_gt,fs_gt,tb1);
new_noisy=gt_timedomain(x',fs,wave_gt,fs_gt,tb1);

%calculate snr and generate plots
plots_and_numbers;
%pause(10);
fprintf('Autotuning with ground truth algo4 finishes!\n\n');

%soundwave animation
%shift_example; 

%Autotune with groud truth alg1,2,3 and without groud truth
fprintf('Autotuning with ground truth algo1,2,3 and without ground truth starts!\n\n');
run_without_ground_truth(wave,fs);
run_with_ground_truth(1,wave,fs);
run_with_ground_truth(2,wave,fs);
run_with_ground_truth(3,wave,fs);
fprintf('Autotuning with ground truth algo1,2,3 and without ground truth algo1 finishes!\n\n');

fprintf('Autotuning without ground truth algo2 starts!\n\n');
PhaseVocoderDemo;
fprintf('Autotuning without ground truth algo2 finishes!\n\n');

%end
fprintf('\n\nAll plots, numbers and soundtracks generated.\n\n\n');