function [matched_s, matched_Y] = MatchWithGroundTruth(s, gt_s, freq, Y, gt_Y, thres, alg)

  [y, x] = size(s);
  matched_Y = Y;
  matched_s = s;

  % setup base and thres for spectrogram moving
  % thres = 100;

  if alg == 1
      fprintf('Runing Autotune with ground truth Algorithm 1: cloumn wise\n');
      % Algorithm 1
      Y_index = [];
      gt_Y_index = [];
      for i = 1:x
        Y_index = [];
        gt_Y_index = [];
        for j = 1:y
          if Y(j, i) > thres
            Y_index = [Y_index; [j,i, Y(j, i)]];
          end
          if gt_Y(j, i) > thres
            gt_Y_index = [gt_Y_index; [j, i, gt_Y(j, i)]];
          end
        end
        Y_index = sortrows(Y_index);
        gt_Y_index = sortrows(gt_Y_index);
        % disp(min(size(Y_index, 1), size(gt_Y_index, 1)));
        % disp(Y_index);
        % fprintf('----------------\n');
        % disp(gt_Y_index);
        % fprintf('================\n');

        for k = 1:min(size(Y_index, 1), size(gt_Y_index, 1))
          Y_tmp = matched_Y(Y_index(k,1), Y_index(k,2));
          matched_Y(Y_index(k,1), Y_index(k,2)) = matched_Y(gt_Y_index(k,1), gt_Y_index(k,2));
          matched_Y(gt_Y_index(k,1), gt_Y_index(k,2)) = Y_tmp;

          s_tmp = matched_s(Y_index(k,1), Y_index(k,2));
          matched_s(Y_index(k,1), Y_index(k,2)) = matched_s(gt_Y_index(k,1), gt_Y_index(k,2));
          matched_s(gt_Y_index(k,1), gt_Y_index(k,2)) = s_tmp;
        end
      end

    elseif alg == 2
      fprintf('Runing Autotune with ground truth Algorithm 2: segment wise\n');
      % Algorithm 2
      Y_col_mean = mean(Y);
      Y_col_mean_shift = circshift(Y_col_mean,1);
      Y_col_diff = Y_col_mean - Y_col_mean_shift;
      Y_col_diff(1) = 0;

      Y_gt_col_mean = mean(Y);
      Y_gt_col_mean_shift = circshift(Y_gt_col_mean,1);
      Y_gt_col_diff = Y_gt_col_mean - Y_gt_col_mean_shift;
      Y_gt_col_diff(1) = 0;

      Y_divider = [];
      Y_gt_divider = [];

      i = 1;
      while i <= x
        flag = 0;
        if Y_col_diff(i) > 3
          Y_divider = [Y_divider; [i]];
          flag = 1;
        end
        if Y_gt_col_diff(i) > 3
          Y_gt_divider = [Y_gt_divider; [i]];
          flag = 1;
        end
        if flag == 1
          i = i+10;
        else
          i = i+1;
        end
      end

      Y_index = [];
      Y_gt_index = [];
      for i = 1:length(Y_divider)-1
        Y_index = [];
        Y_gt_index = [];
        for j = 1:y
          if mean(Y(j, Y_divider(i):Y_divider(i+1))) > thres
            Y_index = [Y_index; [j,i, mean(Y(j, Y_divider(i):Y_divider(i+1)))]];
          end
          if mean(gt_Y(j, Y_gt_divider(i):Y_gt_divider(i+1))) > thres
            Y_gt_index = [Y_gt_index; [j, i, mean(gt_Y(j, Y_gt_divider(i):Y_gt_divider(i+1)))]];
          end
        end
        Y_index = sortrows(Y_index, 3);
        Y_gt_index = sortrows(Y_gt_index, 3);

        for k = 1:min(size(Y_index, 1), size(Y_gt_index, 1))
          Y_tmp = matched_Y(Y_index(k,1), Y_divider(Y_index(k,2)):Y_divider(Y_index(k,2)+1));
          matched_Y(Y_index(k,1), Y_divider(Y_index(k,2)):Y_divider(Y_index(k,2)+1)) = matched_Y(Y_gt_index(k,1), Y_gt_divider(Y_gt_index(k,2)):Y_gt_divider(Y_gt_index(k,2)+1));
          matched_Y(Y_gt_index(k,1), Y_gt_divider(Y_gt_index(k,2)):Y_gt_divider(Y_gt_index(k,2)+1)) = Y_tmp;

          s_tmp = matched_s(Y_index(k,1), Y_divider(Y_index(k,2)):Y_divider(Y_index(k,2)+1));
          matched_s(Y_index(k,1), Y_divider(Y_index(k,2)):Y_divider(Y_index(k,2)+1)) = matched_s(Y_gt_index(k,1), Y_gt_divider(Y_gt_index(k,2)):Y_gt_divider(Y_gt_index(k,2)+1));
          matched_s(Y_gt_index(k,1), Y_gt_divider(Y_gt_index(k,2)):Y_gt_divider(Y_gt_index(k,2)+1)) = s_tmp;
        end
      end

  elseif alg == 3
      fprintf('Runing Autotune with ground truth Algorithm 3: pitch wise\n');
      % Algorithm 3
      Y_col_mean = mean(Y);
      Y_col_mean_shift = circshift(Y_col_mean,1);
      Y_col_diff = Y_col_mean - Y_col_mean_shift;
      Y_col_diff(1) = 0;

      Y_gt_col_mean = mean(Y);
      Y_gt_col_mean_shift = circshift(Y_gt_col_mean,1);
      Y_gt_col_diff = Y_gt_col_mean - Y_gt_col_mean_shift;
      Y_gt_col_diff(1) = 0;

      Y_divider = [];
      Y_gt_divider = [];

      i = 1;
      while i <= x
        flag = 0;
        if Y_col_diff(i) > 3
          Y_divider = [Y_divider; [i]];
          flag = 1;
        end
        if Y_gt_col_diff(i) > 3
          Y_gt_divider = [Y_gt_divider; [i]];
          flag = 1;
        end
        if flag == 1
          i = i+10;
        else
          i = i+1;
        end
      end
      Y_divider = [Y_divider; [x]];
      Y_gt_divider = [Y_gt_divider; [x]];


      h_t = 100;
      l_t = 90;
      Y_state = 0;
      Y_gt_state = 0;
      Y_index = [];
      Y_gt_index = [];
      plot_y = [];
      plot_y_gt = [];
      for i = 1:uint8(length(Y_divider)-1)
        Y_index = [0];
        Y_gt_index = [0];
        for j = 9:y-9
          % fprintf('%d,%d,%d,%f\n', j, Y_divider(i), Y_divider(i+1), mean(Y(j, Y_divider(i):Y_divider(i+1))))
          % disp(mean(Y(j, Y_divider(i):Y_divider(i+1))));
          plot_y = [plot_y; [mean(Y(j-0, Y_divider(i):Y_divider(i+1)))]];
          plot_y_gt = [plot_y_gt; [mean(gt_Y(j-0, Y_gt_divider(i):Y_gt_divider(i+1)))]];
          if mean(Y(j-8, Y_divider(i):Y_divider(i+1))) < mean(Y(j-7, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j-7, Y_divider(i):Y_divider(i+1))) < mean(Y(j-6, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j-6, Y_divider(i):Y_divider(i+1))) < mean(Y(j-5, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j-5, Y_divider(i):Y_divider(i+1))) < mean(Y(j-4, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j-4, Y_divider(i):Y_divider(i+1))) < mean(Y(j-3, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j-3, Y_divider(i):Y_divider(i+1))) < mean(Y(j-2, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j-2, Y_divider(i):Y_divider(i+1))) < mean(Y(j-1, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j-1, Y_divider(i):Y_divider(i+1))) < mean(Y(j-0, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j-0, Y_divider(i):Y_divider(i+1))) > mean(Y(j+1, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j+1, Y_divider(i):Y_divider(i+1))) > mean(Y(j+2, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j+2, Y_divider(i):Y_divider(i+1))) > mean(Y(j+3, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j+3, Y_divider(i):Y_divider(i+1))) > mean(Y(j+4, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j+4, Y_divider(i):Y_divider(i+1))) > mean(Y(j+5, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j+5, Y_divider(i):Y_divider(i+1))) > mean(Y(j+6, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j+6, Y_divider(i):Y_divider(i+1))) > mean(Y(j+7, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j+7, Y_divider(i):Y_divider(i+1))) > mean(Y(j+8, Y_divider(i):Y_divider(i+1))) &&...
             mean(Y(j+7, Y_divider(i):Y_divider(i+1))) > 60
            Y_index = [Y_index; [j]];
          end
            if mean(gt_Y(j-4, Y_gt_divider(i):Y_gt_divider(i+1))) < mean(Y(j-3, Y_gt_divider(i):Y_gt_divider(i+1))) &&...
               mean(gt_Y(j-3, Y_gt_divider(i):Y_gt_divider(i+1))) < mean(Y(j-2, Y_gt_divider(i):Y_gt_divider(i+1))) &&...
               mean(gt_Y(j-2, Y_gt_divider(i):Y_gt_divider(i+1))) < mean(Y(j-1, Y_gt_divider(i):Y_gt_divider(i+1))) &&...
               mean(gt_Y(j-1, Y_gt_divider(i):Y_gt_divider(i+1))) < mean(Y(j-0, Y_gt_divider(i):Y_gt_divider(i+1))) &&...
               mean(gt_Y(j-0, Y_gt_divider(i):Y_gt_divider(i+1))) > mean(Y(j+1, Y_gt_divider(i):Y_gt_divider(i+1))) &&...
               mean(gt_Y(j+1, Y_gt_divider(i):Y_gt_divider(i+1))) > mean(Y(j+2, Y_gt_divider(i):Y_gt_divider(i+1))) &&...
               mean(gt_Y(j+2, Y_gt_divider(i):Y_gt_divider(i+1))) > mean(Y(j+3, Y_gt_divider(i):Y_gt_divider(i+1))) &&...
               mean(gt_Y(j+3, Y_gt_divider(i):Y_gt_divider(i+1))) > mean(Y(j+4, Y_gt_divider(i):Y_gt_divider(i+1))) &&...
               mean(gt_Y(j-0, Y_gt_divider(i):Y_gt_divider(i+1))) > 60
            Y_gt_index = [Y_gt_index; [j]];
          end
        end
        % Y_index = sortrows(Y_index);
        % Y_gt_index = sortrows(Y_gt_index);
        % plot(plot_y); hold on; plot(plot_y_gt);
        for k = 1:uint8(min(size(Y_index, 1), size(Y_gt_index, 1))-2)
          matched_Y(floor((Y_gt_index(k)+Y_gt_index(k+1))/2):floor((Y_gt_index(k)+Y_gt_index(k+1))/2)+floor((Y_index(k+1)+Y_index(k+2))/2)-floor((Y_index(k)+Y_index(k+1))/2), Y_divider(i):Y_divider(i+1)) = Y(floor((Y_index(k)+Y_index(k+1))/2):floor((Y_index(k+1)+Y_index(k+2))/2), Y_divider(i):Y_gt_divider(i+1));
          matched_s(floor((Y_gt_index(k)+Y_gt_index(k+1))/2):floor((Y_gt_index(k)+Y_gt_index(k+1))/2)+floor((Y_index(k+1)+Y_index(k+2))/2)-floor((Y_index(k)+Y_index(k+1))/2), Y_divider(i):Y_divider(i+1)) = s(floor((Y_index(k)+Y_index(k+1))/2):floor((Y_index(k+1)+Y_index(k+2))/2), Y_divider(i):Y_gt_divider(i+1));
          % matched_s(Y_index(k,1), Y_divider(Y_index(k,2)):Y_divider(Y_index(k,2)+1)) = matched_s(Y_gt_index(k,1), Y_gt_divider(Y_gt_index(k,2)):Y_gt_divider(Y_gt_index(k,2)+1));
        end
      end
  end
end