%use the PSOLA
%detect gt dominant frequency inside a fixed window -> f_gt
%detect unitary pitch inside target soundtrack: target (array)
%OLA

function newwave = gt_timedomain(wave,fs,wave_gt,fs_gt,tbin)


fL=fs*0.04; % ?s per frame
fL=floor(fL);
j=1;
waveseg=[];
wave_gtseg=[];
tb=floor(fs*tbin);
for i=tb:fL:numel(wave)-fL+1
    waveseg=[waveseg;wave(i:i+fL-1)];
    wave_gtseg=[wave_gtseg;wave_gt(i:i+fL-1)];
end

%now we have the segments
%apply pitch detection and PSOLA for each small part
[R C]=size(waveseg); % R is number of segs, C is length of one seg

newwaveseg=[];

for i=1:R
   wseg=waveseg(i,:);
   wgtseg=wave_gtseg(i,:);
   
   [wfreq w_gtfreq] = find_freq(wseg,wgtseg,fs);
   if(wfreq==-1||w_gtfreq==-1)
       continue;
   end
 
   wpitch=PeriodMatrix(wseg,wfreq);
   
   %shift
   newseg=myPSOLA(wpitch,length(wseg),floor(44100/w_gtfreq));
   newwaveseg(i,:)=newseg;
end

newwave=zeros(1,tb);
for i=1:1:numel(newwaveseg(:,1))
    newwave=[newwave,newwaveseg(i,:)];
end

%smooth
h1=[1 1 1 1 1 2 2 10 2 2 1 1 1 1 1];
h1=h1./norm(h1,2);
new_wave = cwt(newwave,'morse',fs,'FrequencyLimits',[20 20000],'VoicesPerOctave',10);
new_wave_sm=conv2(h1,new_wave);
newwave=icwt(new_wave_sm);
end