function newseg = myPSOLA(wpitch,L,targetfL)
% L is target total length
% wpitch is windowed pitch matrix
% scale = targetfreq/originalfreq = C/targetfL
    [R C] = size(wpitch); % R windowed pitches each has length C
    fL=C;
    scale=C/targetfL;
    newseg=zeros(1,L);
    if(scale==1)
        % no scale
        for i=1:R
            tbegin=1+fL/2*(i-1);
            tend=tbegin+fL-1;
            newseg(tbegin:tend)=newseg(tbegin:tend) + wpitch(i,:);
        end
        return;
    end
    if(scale>1) 
        newR=floor(R*scale);
        excR=newR-R; % how many R we need to insert
        meaninterval = floor(newR/excR);
        j=1;
        for i=1:newR
            tbegin=1+floor(targetfL/2*(i-1));
            tend=tbegin+fL-1;
            if(j>R)
                j=j-1;
            end
            thiswp = wpitch(j,:);
            if(mod(i,meaninterval)~=0)
            j=j+1;
            end
            if(tend>L)
                continue;
            end
            newseg(tbegin:tend)=newseg(tbegin:tend) + thiswp;
        end
        newseg=newseg(1:L);
        return;
    end
    if(scale<1)
        newR=floor(R*scale);
        misR=R-newR;
        meaninterval=floor(R/misR);
        j=1;
        for i=1:R
            tbegin=1+floor(targetfL/2*(i-1));
            tend=tbegin+fL-1;
            thiswp = wpitch(j,:);
            if(mod(i,meaninterval)==0)
                j=j+2;
            else
                j=j+1;
            end
            if(j>R)
                j=j-2;
            end
            if(tend>L)
                continue;
            end
            newseg(tbegin:tend)=newseg(tbegin:tend) + thiswp;
        end
        return;
    end
end