function [s_corrected, Y_corrected] = pitchCorrector(s, freq, Y, pitchtable, midpitchtable)

  [y, x] = size(s);
  Y_corrected = Y;
  s_corrected = s;

  % setup base and thres for spectrogram moving
  base = 40;
  thres = 100;
  count = 0;
  for i = 1:x
    for j = 1:y
      if Y(j, i) > thres
        count = count+1;
        closest_pitch = compareToPitches(freq(j), pitchtable, midpitchtable);
        index = ClosestPitchToIndex(closest_pitch, freq);
        Y_dif = Y(j, i)-base;
        s_dif = Y_dif/Y(j, i)*s(j, i);
        s_corrected(index, i) = s_corrected(index, i)+s_dif;
        s_corrected(j, i) = s_corrected(j, i)-s_dif;
        Y_corrected(index, i) = Y_corrected(index, i)+Y_dif;
        Y_corrected(j, i) = Y_corrected(j, i)-Y_dif;
        % fprintf('freq(j)=%f, closest_pitch=%f', freq(j), closest_pitch);
        % fprintf('j=%d, index=%d\n', j, index);
      end
    end
  end
%   disp(count);
end
