minfreq=20;
maxfreq=20000;
VPO=10;
tbegin=0;
tend=8;
[xori, fs] = audioread('tbt.wav');
xori=xori(fs*tbegin+1:fs*tend+1,1);
xnoise=x(1:fs*tend)'-xori(1:fs*tend)';
SNR=15;
t=1/fs:1/fs:min([numel(new),numel(x),numel(xori)])/fs;
tlast=min([numel(new),numel(x),numel(xori)]);
snrbefore = snr(x(1:tlast)',xnoise(1:tlast));
snrafter = snr(new(1:tlast),xnoise(1:tlast));

fp=fopen('SNR.txt','w');
fprintf(fp,'Noisy To Be Tuned Signal SNR = %4.2f\n\r\n\r',snrbefore);
fprintf(fp,'Denoised and Autotuned Signal SNR = %4.2f\n\r',snrafter);
fclose(fp);

figure();
cwt(wave_gt,'morse',fs,'FrequencyLimits',[minfreq maxfreq],'VoicesPerOctave',VPO); title('Clean Ground Truth Signal Spectrogram');
saveas(gcf,'Spectrogram1.bmp','bmp');


figure();
cwt(xori,'morse',fs,'FrequencyLimits',[minfreq maxfreq],'VoicesPerOctave',VPO); title('Clean To Be Tuned Signal Spectrogram');
saveas(gcf,'Spectrogram2.bmp','bmp');

figure();
cwt(x,'morse',fs,'FrequencyLimits',[minfreq maxfreq],'VoicesPerOctave',VPO); title('Noisy To Be Tuned Signal Spectrogram');
saveas(gcf,'Spectrogram3.bmp','bmp');

figure();
cwt(wave,'morse',fs,'FrequencyLimits',[minfreq maxfreq],'VoicesPerOctave',VPO); title('Only Denoised Signal Spectrogram');
saveas(gcf,'Spectrogram4.bmp','bmp');

figure();
cwt(new,'morse',fs,'FrequencyLimits',[minfreq maxfreq],'VoicesPerOctave',VPO); title('Denoised and Autotuned Signal Spectrogram');
saveas(gcf,'Spectrogram5.bmp','bmp');

figure();
subplot(3,1,1);
plot(t,xori(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Clean To Be Tuned Signal Waveform');
subplot(3,1,2);
plot(t,x(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Noisy To Be Tuned Signal Waveform');
subplot(3,1,3);
plot(t,wave(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Only Denosied Signal Waveform');
saveas(gcf,'Waveform1.bmp','bmp');

x1=2.14;
x2=2.17;
subplot(3,1,1);
plot(t,xori(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Clean To Be Tuned Signal Waveform');
xlim([x1,x2]);
drawnow;
subplot(3,1,2);
plot(t,x(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Noisy To Be Tuned Signal Waveform');
xlim([x1,x2]);
drawnow;
subplot(3,1,3);
plot(t,wave(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Only Denosied Signal Waveform');
xlim([x1,x2]);
drawnow;
saveas(gcf,'Waveform2.bmp','bmp');

x1=4.62;
x2=4.64;
subplot(3,1,1);
plot(t,xori(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Clean To Be Tuned Signal Waveform');
xlim([x1,x2]);
drawnow;
subplot(3,1,2);
plot(t,x(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Noisy To Be Tuned Signal Waveform');
xlim([x1,x2]);
drawnow;
subplot(3,1,3);
plot(t,wave(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Only Denosied Signal Waveform');
xlim([x1,x2]);
drawnow;
saveas(gcf,'Waveform3.bmp','bmp');

x1=4.05;
x2=4.15;
subplot(3,1,1);
plot(t,xori(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Clean To Be Tuned Signal Waveform');
xlim([x1,x2]);
ylim([-1,1]);
drawnow;
subplot(3,1,2);
plot(t,x(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Noisy To Be Tuned Signal Waveform');
xlim([x1,x2]);
ylim([-1,1]);
drawnow;
subplot(3,1,3);
plot(t,wave(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Only Denosied Signal Waveform');
xlim([x1,x2]);
ylim([-1,1]);
drawnow;
saveas(gcf,'Waveform4.bmp','bmp');

x1=2.23;
x2=2.25;
subplot(3,1,1);
plot(t,xori(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Clean To Be Tuned Signal Waveform');
xlim([x1,x2]);
drawnow;
subplot(3,1,2);
plot(t,x(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Noisy To Be Tuned Signal Waveform');
xlim([x1,x2]);
drawnow;
subplot(3,1,3);
plot(t,wave(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Only Denosied Signal Waveform');
xlim([x1,x2]);
drawnow;
saveas(gcf,'Waveform5.bmp','bmp');

x1=2.195;
x2=2.225;
figure();
subplot(4,1,1);
plot(t,xori(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Clean To Be Tuned Signal Waveform');
xlim([x1,x2]);
subplot(4,1,2);
plot(t,x(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Noisy To Be Tuned Signal Waveform');
xlim([x1,x2]);
subplot(4,1,3);
plot(t,new(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Denoised and Autotuned Signal Waveform');
xlim([x1,x2]);
subplot(4,1,4);
plot(t,wave_gt(1:tlast));
xlabel('time (s)');
ylabel('magnitude');
title('Ground Truth Signal Waveform');
xlim([x1,x2]);
saveas(gcf,'Waveform6.bmp','bmp');


audiowrite('Noisy Signal Denoised and Autotuned - algo4.wav',new,fs);
audiowrite('Noisy Signal Only Autotuned - algo4.wav',new_noisy,fs);
audiowrite('Noisy Signal Only Denoised.wav',wave,fs);


