function [] = run_with_ground_truth(alg,wave_ns,fs_ns)
    % Clean audio tuning
    [wave,fs] = audioread('tbt.wav');
    [wave_gt,fs_gt] = audioread('gt.wav');

    wave = wave(:, 1);
    wave_gt = wave_gt(:, 1);
    % cwt(wave,'morse',fs,'FrequencyLimits',[20 20000],'VoicesPerOctave',10);
    % cwt(wave_gt,'morse',fs,'FrequencyLimits',[20 20000],'VoicesPerOctave',10);
    f = 8192;
    [s, freq, time] = spectrogram(wave, hanning(1000), 500, f, fs, 'yaxis');
    [s_ns, freq_ns, time_ns] = spectrogram(wave_ns, hanning(1000), 500, f, fs_ns, 'yaxis');
    [s_gt, freq_gt, time_gt] = spectrogram(wave_gt, hanning(1000), 500, f, fs_gt, 'yaxis');

    s = s+0.01;
    s_gt = s_gt+0.01;
    y = displaydBSpectrogram(s, freq, time);
    title('Clean To Be Tuned Audio');
    y_ns = displaydBSpectrogram(s_ns, freq_ns, time_ns);
    title('Noisy To Be Tuned Audio');
    y_gt = displaydBSpectrogram(s_gt, freq_gt, time_gt);
    title('Ground Truth Audio');


    [s_corrected, y_corrected] = MatchWithGroundTruth(s, s_gt, freq, y, y_gt, 80, alg);
    [s_ns_corrected, y_ns_corrected] = MatchWithGroundTruth(s_ns, s_gt, freq, y_ns, y_gt, 80, alg);

    displaySpectrogram(y_corrected, freq, time);
    title('Clean Tuned Audio');
    if alg == 1
        saveas(gcf, 'Clean_Tuned_Audio_With_Ground_Truth_Alg1.bmp', 'bmp');
    elseif alg == 2
        saveas(gcf, 'Clean_Tuned_Audio_With_Ground_Truth_Alg2.bmp', 'bmp');
    elseif alg == 3
        saveas(gcf, 'Clean_Tuned_Audio_With_Ground_Truth_Alg3.bmp', 'bmp');
    end
    displaySpectrogram(y_ns_corrected, freq, time);
    title('Noisy Tuned Audio');
    if alg == 1
        saveas(gcf, 'Noisy_Tuned_Audio_With_Ground_Truth_Alg1.bmp', 'bmp');
    elseif alg == 2
        saveas(gcf, 'Noisy_Tuned_Audio_With_Ground_Truth_Alg2.bmp', 'bmp');
    elseif alg == 3
        saveas(gcf, 'Noisy_Tuned_Audio_With_Ground_Truth_Alg3.bmp', 'bmp');
    end
    corrected = istft(s_corrected,f,1000,500);
    ns_corrected = istft(s_ns_corrected,f,1000,500);

    h1=[1 1 1 1 1 2 2 10 2 2 1 1 1 1 1];
    h1=h1./norm(h1,2);
    corrected = cwt(corrected,'morse',fs,'FrequencyLimits',[20 20000],'VoicesPerOctave',10);
    corrected = conv2(h1,corrected);
    corrected = icwt(corrected);
    ns_corrected = cwt(ns_corrected,'morse',fs,'FrequencyLimits',[20 20000],'VoicesPerOctave',10);
    ns_corrected = conv2(h1,ns_corrected);
    ns_corrected = icwt(ns_corrected);

    % cwt(corrected,'morse',fs,'FrequencyLimits',[20 20000],'VoicesPerOctave',10);
   % soundsc(corrected, fs); pause(10);
   % soundsc(ns_corrected, fs);
    if alg == 1
        audiowrite('Clean_Tuned_Audio_With_Ground_Truth_Alg1.wav', corrected, fs);
        audiowrite('Noisy_Tuned_Audio_With_Ground_Truth_Alg1.wav', ns_corrected, fs);
    elseif alg == 2
        audiowrite('Clean_Tuned_Audio_With_Ground_Truth_Alg2.wav', corrected, fs);
        audiowrite('Noisy_Tuned_Audio_With_Ground_Truth_Alg2.wav', ns_corrected, fs);
    elseif alg == 3
        audiowrite('Clean_Tuned_Audio_With_Ground_Truth_Alg3.wav', corrected, fs);
        audiowrite('Noisy_Tuned_Audio_With_Ground_Truth_Alg3.wav', ns_corrected, fs);
    end
end
