function [] = run_without_ground_truth(wave_ns,fs)
    fprintf('Autotune without ground truth running...\n');
    %%%%%%%%%%%% clean tunning %%%%%%%%%%%%%%
    [wave,fs] = audioread('tbt.wav');

    wave = wave(:, 1);
    [s, freq, time] = spectrogram(wave, hanning(1000), 500, 1024, 44100, 'yaxis');
    s = s+0.1;
    y = displaydBSpectrogram(s, freq, time);
    title('Clean To Be Tuned Spectrogram');
    [pitchtable, midpitchtable] = PitchTable();
    % soundsc(wave, fs);
    % tic, pause(11), toc;

    [s_corrected, y_corrected] = pitchCorrector(s, freq, y, pitchtable, midpitchtable);
    displaySpectrogram(y_corrected, freq, time);
    title('Clean Tuned Audio');
    saveas(gcf, 'Clean_Tuned_Audio_Without_Ground_Truth.bmp', 'bmp');
    s_corrected = conj(s_corrected);
    corrected = istft(s_corrected,1024,1000,500);
    corrected = corrected';
   % soundsc(corrected, fs);
    audiowrite('Clean_Signal_Tuned_Without_Ground_Truth.wav', corrected, fs);

    %%%%%%%%%%%%% denoised tuning %%%%%%%%%%%%%
    [s, freq, time] = spectrogram(wave_ns, hanning(1000), 500, 1024, 44100, 'yaxis');
    s = s+0.1;
    y = displaydBSpectrogram(s, freq, time);
    title('Denoised To Be Tuned Audio');
    [pitchtable, midpitchtable] = PitchTable();
    % soundsc(wave, fs);
    % tic, pause(11), toc;

    [s_corrected, y_corrected] = pitchCorrector(s, freq, y, pitchtable, midpitchtable);
    displaySpectrogram(y_corrected, freq, time);
    title('Denoised Tuned Audio');
    saveas(gcf, 'Denoised_Tuned_Audio_Without_Ground_Truth.bmp', 'bmp');
    s_corrected = conj(s_corrected);
    corrected = istft(s_corrected,1024,1000,500);
    corrected = corrected';
    %soundsc(corrected, fs);
    audiowrite('Denoised_Signal_Tuned_Without_Ground_Truth.wav', corrected, fs);
end